%Fractions_Derivatives
function [JF,FPR,TPR,PPR,X4PR,X6PR,X8PR,X11PR,H,der_H_T,X]=Fractions_Derivatives(n ...
    ,m,l,k,F,T,p,JF,FPR,TPR,PPR,X4PR,X6PR,X8PR,X11PR)
KLO=1;   
syms OX 
PREC=1*10^(-3);
X=zeros(1,13);
if (T<1080 || T>7200)
    error 'Specified temperature outside 1080 to 7200 R range';
end
%Determination of Constants
ro=(n+(m/4)-(l/2))/F;
r2=0.0444*ro;
r1=(k/2)+(3.7274*ro);
r=(l/2)+ro;
if (r>0.5*n) 
    d(1)=m/n;
    d(2)=2*r/n;
    d(3)=2*r1/n;
    d(4)=r2/n;
else
 error ['Specified equivalence ratio too high as to cause formation of free carbon'] ;
end
%Kp
% Ta:Temperature used for ajusted the coefficients
Ta=0.005*T/9;
%Constant of Reaction 0.5(H2) --> H (C1)
c(1)=(10^(0.432168*log(Ta) + (-0.112464*10^2)/Ta + 0.267269*10 + ...
    (-0.745744*10^(-1))*Ta + (0.242484*10^(-2))*(Ta^2)))/sqrt(p/14.696); 

%Constant of Reaction 0.5(O2) --> O (C2)
c(2)=(10^(0.310805*log(Ta) + (-0.129540*10^2)/Ta + 0.321779*10 + ...
    (-0.738336*10^(-1))*Ta + (0.344645*10^(-2))*(Ta^2)))/sqrt(p/14.696);

%Constant of Reaction 0.5(N2) --> N (C3)
c(3)=(10^(0.389716*log(Ta) + (-0.245828*10^2)/Ta + 0.314505*10 + ...
    (-0.963730*10^(-1))*Ta + (0.585643*10^(-2))*(Ta^2)))/sqrt(p/14.696);

%Constant of Reaction 0.5(O2)+0.5(H2) --> OH (C5)
c(4)=10^(-0.141784*log(Ta) + (-0.213308*10)/Ta + 0.853461 + ...
    (0.355015*10^(-1))*Ta + (-0.310227*10^(-2))*(Ta^2));

%Constant of Reaction 0.5(N2)+0.5(O2) --> NO (C7)
c(5)=10^(0.150879*(10^(-1))*log(Ta) + (-0.470959*10)/Ta + 0.646096 + ...
    (0.272805*10^(-2))*Ta + (-0.154444*10^(-2))*(Ta^2));

%Constant of Reaction H2+0.5(O2) --> H2O (C9)
c(6)=(10^(-0.752364*log(Ta) + (0.124210*10^(2))/Ta + (-0.260286)*10 + ...
    (0.259556)*Ta + (-0.162687*10^(-1))*(Ta^2)))*sqrt(p/14.696);

%Constant of Reaction CO+0.5(O2) --> CO2 (C10)
c(7)=(10^(-0.415302*(10^(-2))*log(Ta) + (0.148627*10^(2))/Ta + ...
    (-0.475746)*10 + (0.124699)*Ta + (-0.900227*10^(-2))*(Ta^2)))*sqrt(p/14.696);
if KLO-1==0
    if JF==0 || (abs(F-FPR)>10^-6) || (abs(T/TPR -1)>0.02) || (abs(p/PPR -1)>0.05)
        if F<=1
          PAR=1/(m*0.25+r+r1+r2);
        else
          PAR=1/(n+0.5*m+r1+r2);
        end
        F1=2*n*c(7);
        F2=0.5*m*c(6);
        F3=2/PAR;
        F4=2*r;
        f=(F1*sqrt(OX)+n)/(1+c(7)*sqrt(OX)) + (F2*sqrt(OX))/(1+c(6)*sqrt(OX))... 
        +F3*OX-F4;
%Newton Raphson used for the determination of the zero:
        df=diff(f);
        ox=1;
        for i=1:20
        fox=double(subs(f,ox));
        dfox=double(subs(df,ox));
        ox1=ox-fox/dfox;
        %In case the first obtained value is negative, ox1 is reduced to it's tenth
        if ox1<0  
        ox1=ox*0.1;
        end
        if (abs(ox-double(ox1))<=0.0000001)
        ox=double(ox1);
        break
        else
        ox=double(ox1);
        end
        end
%X4, X6, X8 and X11 first estimated result obtained:
        X(4)=0.5*m*PAR/(1+c(6)*sqrt(ox));
        X(6)=n*PAR/(1+c(7)*sqrt(ox));
        X(8)=ox;
        X(11)=r1*PAR;
    else
        X(4)=X4PR;
        X(6)=X6PR;
        X(8)=X8PR;
        X(11)=X11PR;
    end
end
for i=1:23
%Equations for the other products are defined using the constants Kp:
X(1)=c(1)*sqrt(X(4));
X(2)=c(2)*sqrt(X(8));
X(3)=c(3)*sqrt(X(11));
X(5)=c(4)*sqrt(X(4))*sqrt(X(8));
X(7)=c(5)*sqrt(X(11))*sqrt(X(8));
X(9)=c(6)*X(4)*sqrt(X(8));
X(10)=c(7)*X(6)*sqrt(X(8));
%Functions and derivatives of every product by other are defined:
T14=0.5*c(1)/sqrt(X(4));
T28=0.5*c(2)/sqrt(X(8));
T311=0.5*c(3)/sqrt(X(11));
T54=0.5*c(4)*sqrt(X(8))/sqrt(X(4));
T58=0.5*c(4)*sqrt(X(4))/sqrt(X(8));
T78=0.5*c(5)*sqrt(X(11))/sqrt(X(8));
T711=0.5*c(5)*sqrt(X(8))/sqrt(X(11));
T94=c(6)*sqrt(X(8));
T98=0.5*c(6)*(X(4))/sqrt(X(8));
T106=c(7)*sqrt(X(8));
T108=0.5*c(7)*(X(6))/sqrt(X(8));
A1(1,1)=T14+2+T54+2*T94;
A1(1,2)=-d(1)*(1+T106);
A1(1,3)=(T58+2*T98)-d(1)*T108;
A1(1,4)=0;
A1(2,1)=T54+T94;
A1(2,2)=(1+2*T106)-d(2)*(1+T106);
A1(2,3)=(T28+T58+T78+2+T98+2*T108)-d(2)*T108;
A1(2,4)=T711;
A1(3,1)=0;
A1(3,2)=-d(3)*(1+T106);
A1(3,3)=T78-d(3)*T108;
A1(3,4)=T311+T711+2;
A1(4,1)=T14+1+T54+T94;
A1(4,2)=1+T106+d(4)*(1+T106);
A1(4,3)=T28+T58+T78+1+T98+T108+d(4)*T108;
A1(4,4)=T311+T711+1;
B1(1)=-(X(1)+2*X(4)+X(5)+2*X(9))+d(1)*(X(6)+X(10));
B1(2)=-(X(2)+X(5)+X(6)+X(7)+2*X(8)+X(9)+2*X(10))+d(2)*(X(6)+X(10));
B1(3)=-(X(3)+X(7)+2*X(11))+d(3)*(X(6)+X(10));
B1(4)=-(X(1)+X(2)+X(3)+X(4)+X(5)+X(6)+X(7)+X(8)+X(9)+X(10)+X(11)+d(4)*(X(6)+X(10)))+1;
for k=1:3
    KP1=k+1;
    BIG=abs(A1(k,k));
    if (BIG<10^-5)
        IBIG=k;
        for I=KP1:4
            if abs(A1(I,k))<=BIG
                break
            else
                BIG=abs(A1(I,k));
                IBIG=I;
            end
        end
        if (BIG>0)
            if (IBIG~=k)
                for J=k:4
                    TERM=A1(k,J);
                    A1(k,J)=A1(IBIG,J);
                    A1(IBIG,J)=TERM;
                end
                TERM=B1(k);
                B1(k)=B1(IBIG);
                B1(IBIG)=TERM;
            else
                for I=KP1:4
                    TERM=A1(I,k)/A1(k,k);
                    for J=KP1:4
                        A1(I,J)=A1(I,J)-A1(k,J)*TERM;
                    end
                    B1(I)=B1(I)-B1(k)*TERM;
                end
            end
        end
    else
         for I=KP1:4
                    TERM=A1(I,k)/A1(k,k);
                    for J=KP1:4
                        A1(I,J)=A1(I,J)-A1(k,J)*TERM;
                    end
                    B1(I)=B1(I)-B1(k)*TERM;
         end       
    end
end 
if (abs(A1(4,4))>0)
B1(4)=B1(4)/A1(4,4);
B1(3)=(B1(3)-A1(3,4)*B1(4))/A1(3,3);
B1(2)=(B1(2)-A1(2,3)*B1(3)-A1(2,4)*B1(4))/A1(2,2);
B1(1)=(B1(1)-A1(1,2)*B1(2)-A1(1,3)*B1(3)-A1(1,4)*B1(4))/A1(1,1);
else
  error ['A singular matrix was encountered during calculatin of partial derivatives of mole fractions'];
end         
%The values of X4, X6, X8 and X11 are recalculated in order to adjust them
X(4)=X(4)+B1(1);
new_iteration='No';
%Verification of the tolerance
if abs(B1(1)/X(4))>PREC
    new_iteration='Yes';
end
X(6)=X(6)+B1(2);
if abs(B1(2)/X(6))>PREC
    new_iteration='Yes';
end
X(8)=X(8)+B1(3);
if abs(B1(3)/X(8))>PREC
    new_iteration='Yes';
end
X(11)=X(11)+B1(4);
if abs(B1(4)/X(11))>PREC
    new_iteration='Yes';
end
%In case the tolerance is OK, the other products are calculated
if isequal(new_iteration,'No') && X(6)>0
JF=1;
FPR=F;
TPR=T;
PPR=p;
X4PR=X(4);
X6PR=X(6);
X8PR=X(8);
X11PR=X(11);
    break %end of for loop 
end
end
X(1)=c(1)*sqrt(X(4));
X(2)=c(2)*sqrt(X(8));
X(3)=c(3)*sqrt(X(11));
X(5)=c(4)*sqrt(X(4))*sqrt(X(8));
X(7)=c(5)*sqrt(X(11))*sqrt(X(8));
X(9)=c(6)*X(4)*sqrt(X(8));
X(10)=c(7)*X(6)*sqrt(X(8));
X(13)=(X(6)+X(10))/n;
X(12)=r2*X(13);
%Recalculate the variables for post necessary calculus
T14=0.5*c(1)/sqrt(X(4));
T28=0.5*c(1)/sqrt(X(8));
T311=0.5*c(3)/sqrt(X(11));
T54=0.5*c(4)*sqrt(X(8))/sqrt(X(4));
T58=0.5*c(4)*sqrt(X(4))/sqrt(X(8));
T78=0.5*c(5)*sqrt(X(11))/sqrt(X(8));
T711=0.5*c(5)*sqrt(X(8))/sqrt(X(11));
T94=c(6)*sqrt(X(8));
T98=0.5*c(6)*(X(4))/sqrt(X(8));
T106=c(7)*sqrt(X(8));
T108=0.5*c(7)*(X(6))/sqrt(X(8));
A1(1,1)=T14+2+T54+2*T94;
A1(1,2)=-d(1)*(1+T106);
A1(1,3)=(T58+2*T98)-d(1)*T108;
A1(1,4)=0;
A1(2,1)=T54+T94;
A1(2,2)=(1+2*T106)-d(2)*(1+T106);
A1(2,3)=(T28+T58+T78+2+T98+2*T108)-d(2)*T108;
A1(2,4)=T711;
A1(3,1)=0;
A1(3,2)=-d(3)*(1+T106);
A1(3,3)=T78-d(3)*T108;
A1(3,4)=T311+T711+2;
A1(4,1)=T14+1+T54+T94;
A1(4,2)=1+T106+d(4)*(1+T106);
A1(4,3)=T28+T58+T78+1+T98+T108+d(4)*T108;
A1(4,4)=T311+T711+1;
%Properties of products are read
data = readtable('Products.xlsx');
SM = data.SM; %Molar Mass
HT = data.HT; %Enthalpy
CT = data.CT; %Specific Heat capacity
%Definition of derivatives respect temperature, pressure and ratio
%Respect Temperature
DC1T=X(1)*(0.005/9)*log(10)*(0.432168/Ta -(-0.112464*10^(2))/(Ta^2) + ...
    -0.745744*10^(-1) +2*Ta*0.242484*10^(-2));
DC2T=X(2)*(0.005/9)*log(10)*(0.310805/Ta -(-0.129540*100)/(Ta^2) + ...
    -0.738336*0.1 +2*Ta*0.344645*10^(-2));
DC3T=X(3)*(0.005/9)*log(10)*(0.389716/Ta -(-0.245828*100)/(Ta^2) + ...
    -0.963730*0.1 + 2*Ta*0.585643*10^(-2));
DC5T=X(5)*(0.005/9)*log(10)*(-0.141784/Ta -(-0.213308*10)/(Ta^2) + ...
    0.355015*0.1 + 2*Ta*(-0.310227*10^(-2)));
DC7T=X(7)*(0.005/9)*log(10)*(0.150879*(10^(-1))/Ta -(-0.470959*10)/(Ta^2) + ...
    0.272805*0.01 + 2*Ta*(-0.154444*10^(-2)));
DC9T=X(9)*(0.005/9)*log(10)*(-0.752364/Ta - 0.124210*100/(Ta^2) + ...
    0.259556 + 2*Ta*(-0.162687*0.1));
DC10T=X(10)*(0.005/9)*log(10)*(-0.415302*(10^(-2))/Ta - 0.148627*100/(Ta^2) + ...
    0.124699 + 2*Ta*(-0.900227*10^(-2)));
%Respect Pressure
PP2=0.5/p;
DC1P=-X(1)*PP2;
DC2P=-X(2)*PP2;
DC3P=-X(3)*PP2;
DC9P=X(9)*PP2;
DC10P=X(10)*PP2;
%Respect Ratio
d(5)=-ro*X(13)/F;
DD4F=0.0444*d(5);
C1(1,1)=-(DC1T+DC5T+2*DC9T-d(1)*DC10T);
C1(2,1)=-(DC2T+DC5T+DC7T+DC9T+(2-d(2))*DC10T);
C1(3,1)=-(DC3T+DC7T-d(3)*DC10T);
C1(4,1)=-(DC1T+DC2T+DC3T+DC5T+DC7T+DC9T+(1+d(4))*DC10T);
C1(1,2)=-(DC1P+2*DC9P-d(1)*DC10P);
C1(2,2)=-(DC2P+DC9P+(2-d(2))*DC10P);
C1(3,2)=-(DC3P-d(3)*DC10P);
C1(4,2)=-(DC1P+DC2P+DC3P+DC9P+(1+d(4))*DC10P);
C1(1,3)=0;
C1(2,3)=2*d(5);
C1(3,3)=7.4548*d(5);
C1(4,3)=-DD4F;
for k=1:3
KP1=k+1;
AMAX=abs(A1(k,k));
MAX=k;
    for I=KP1:4
        if (abs(A1(I,k))>AMAX)
            AMAX=abs(A1(I,k));
            MAX=I;
        else
           break
        end
    end
    if AMAX>0
        if MAX~=k
            for J=k:4
                TERM=A1(k,J);
                A1(k,J)=A1(MAX,J);
                A1(MAX,J)=TERM;
            end
            for J=1:3
                TERM=C1(k,J);
                C1(k,J)=C1(MAX,J);
                C1(MAX,J)=TERM;
            end
        end
        for I=KP1:4
            TERM=A1(I,k)/A1(k,k);
            for J=KP1:4
                A1(I,J)=A1(I,J)-A1(k,J)*TERM;
            end
            for J=1:3
                C1(I,J)=C1(I,J)-C1(k,J)*TERM;
            end
        end
    end
end
if(abs(A1(4,4))>0)
    for J=1:3
        C1(4,J)=C1(4,J)/A1(4,4);
        C1(3,J)=(C1(3,J)-A1(3,4)*C1(4,J))/A1(3,3);
        C1(2,J)=(C1(2,J)-A1(2,3)*C1(3,J)-A1(2,4)*C1(4,J))/A1(2,2);
        C1(1,J)=(C1(1,J)-A1(1,2)*C1(2,J)-A1(1,3)*C1(3,J)-A1(1,4)*C1(4,J))/A1(1,1);
    end
else
  error ['A singular matrix was encountered during calculatin of partial derivatives of mole fractions'];
end
der_X_T(4)=C1(1,1);
der_X_T(6)=C1(2,1);
der_X_T(8)=C1(3,1);
der_X_T(11)=C1(4,1);
der_X_P(4)=C1(1,2);
der_X_P(6)=C1(2,2);
der_X_P(8)=C1(3,2);
der_X_P(11)=C1(4,2);
der_X_F(4)=C1(1,3);
der_X_F(6)=C1(2,3);
der_X_F(8)=C1(3,3);
der_X_F(11)=C1(4,3);
der_X_T(1)=T14*der_X_T(4)+DC1T;
der_X_T(2)=T28*der_X_T(8)+DC2T;
der_X_T(3)=T311*der_X_T(11)+DC3T;
der_X_T(5)=T54*der_X_T(4)+T58*der_X_T(8)+DC5T;
der_X_T(7)=T78*der_X_T(8)+T711*der_X_T(11)+DC7T;
der_X_T(9)=T94*der_X_T(4)+T98*der_X_T(8)+DC9T;
der_X_T(10)=T106*der_X_T(6)+T108*der_X_T(8)+DC10T;
der_X_T(12)=d(4)*(der_X_T(6)+der_X_T(10));
der_X_P(1)=T14*der_X_P(4)+DC1P;
der_X_P(2)=T28*der_X_P(8)+DC2P;
der_X_P(3)=T311*der_X_P(11)+DC3P;
der_X_P(5)=T54*der_X_P(4)+T58*der_X_P(8);
der_X_P(7)=T78*der_X_P(8)+T711*der_X_P(11);
der_X_P(9)=T94*der_X_P(4)+T98*der_X_P(8)+DC9P;
der_X_P(10)=T106*der_X_P(6)+T108*der_X_P(8)+DC10P;
der_X_P(12)=d(4)*(der_X_P(6)+der_X_P(10));
der_X_F(1)=T14*der_X_F(4);
der_X_F(2)=T28*der_X_F(8);
der_X_F(3)=T311*der_X_F(11);
der_X_F(5)=T54*der_X_F(4)+T58*der_X_F(8);
der_X_F(7)=T78*der_X_F(8)+T711*der_X_F(11);
der_X_F(9)=T94*der_X_F(4)+T98*der_X_F(8);
der_X_F(10)=T106*der_X_F(6)+T108*der_X_F(8);
der_X_F(12)=d(4)*(der_X_F(6)+der_X_F(10))+DD4F;
%Determination of the AVM, Cp of gases and  enthalpy 
Tk=T/180;
IT=fix(Tk);
FR=Tk-IT;
SH(1)=92935.8+4.968*T;
SH(12)=4.968*T;
for i=2:11
    IN=(35*(i-2)+(IT-5));
    SH(i)=(HT(IN)+FR*(HT(IN+1)-HT(IN)))*1800;
end
AVM=0;
H=0;
for z=1:12
    AVM=AVM+X(z)*SM(z);
    H=H+X(z)*SH(z);
end
H=H/AVM;
%Determination of the partial derivatives respect T, P and F for H and M
der_M_T=der_X_T(1)*SM(1)+der_X_T(12)*SM(12);
der_H_T=X(1)*4.968+der_X_T(1)*SH(1)+X(12)*4.968+der_X_T(12)*SH(12);
der_M_P=der_X_P(1)*SM(1)+der_X_P(12)*SM(12);
der_H_P=der_X_P(1)*SH(1)+der_X_P(12)*SH(12);
der_M_F=der_X_F(1)*SM(1)+der_X_F(12)*SM(12);
der_H_F=der_X_F(1)*SH(1)+der_X_F(12)*SH(12);
for j=2:11
    indice=(35*(j-2)+(IT-5));
    CP=CT(indice)+FR*(CT(indice+1)-CT(indice));
    der_M_T=der_M_T+der_X_T(j)*SM(j);
    der_H_T=der_H_T+X(j)*CP+der_X_T(j)*SH(j);
    der_M_P=der_M_P+der_X_P(j)*SM(j);
    der_H_P=der_H_P+der_X_P(j)*SH(j);
    der_M_F=der_M_F+der_X_F(j)*SM(j);
    der_H_F=der_H_F+der_X_F(j)*SH(j);
end
der_H_T=(der_H_T-der_M_T*H)/AVM;
end




